dofile(ModPath .. "lua/core.lua")

_G.HUDCleaner = _G.HUDCleaner or {}

if RequiredScript == "lib/managers/lootmanager" then
	if HUDCleaner._settings.HUDC_small then
		function LootManager:show_small_loot_taken_hint(type, multiplier) end
	end
end

if RequiredScript == "lib/managers/hudmanager" then
	if HUDCleaner._settings.HUDC_hud then
		function HUDManager:present_mid_text(params) end
	end
end

if RequiredScript == "lib/managers/gageassignmentmanager" then
	if HUDCleaner._settings.HUDC_gage then
		function GageAssignmentManager:present_progress(assignment, peer_name) end
		function GageAssignmentManager:_present_progress(assignment, collected, to_aquire) end
	end
end

if RequiredScript == "lib/managers/localizationmanager" then
	if HUDCleaner._settings.HUDC_invalid then
		local text_original = LocalizationManager.text
		local testAllStrings = false
		function LocalizationManager:text(string_id, ...) return string_id == "hud_deploy_valid_help" and " "..string.char(10).." " or testAllStrings == true and string_id or text_original(self, string_id, ...) end
	end
end

if RequiredScript == "lib/managers/localizationmanager" then
	if HUDCleaner._settings.HUDC_maskup then
		local text_original = LocalizationManager.text
		local testAllStrings = false
		function LocalizationManager:text(string_id, ...) return string_id == "hud_instruct_mask_on_alpha" and " "..string.char(10).." " or string_id == "hud_instruct_mask_on" and " "..string.char(10).." " or testAllStrings == true and string_id or text_original(self, string_id, ...) end -- _alpha is for res hud support
	end
end

if RequiredScript == "lib/managers/localizationmanager" then
	if HUDCleaner._settings.HUDC_eq then
		local text_original = LocalizationManager.text
		local testAllStrings = false
		function LocalizationManager:text(string_id, ...) return string_id == "hud_deploying_equipment" and " "..string.char(10).." " or testAllStrings == true and string_id or text_original(self, string_id, ...) end
	end
end

if RequiredScript == "lib/managers/localizationmanager" then
	if HUDCleaner._settings.HUDC_casing then
		local text_original = LocalizationManager.text
		local testAllStrings = false
		function LocalizationManager:text(string_id, ...) return string_id == "hud_casing_mode_ticker" and "Casing Mode" or testAllStrings == true and string_id or text_original(self, string_id, ...) end
	end
end

local resmod = BLT.Mods:GetModByName("RestorationMod") or BLT.Mods:GetModByName("RestorationHUD")
local resmod_found = false
if resmod and resmod:IsEnabled() then
	resmod_found = true
	--log("resmod found")
end

if RequiredScript == "lib/managers/hud/hudheisttimer" then
	function HUDHeistTimer:init(hud, tweak_hud)
		self._hud_panel = hud.panel

		if self._hud_panel:child("heist_timer_panel") then
			self._hud_panel:remove(self._hud_panel:child("heist_timer_panel"))
		end

		if HUDCleaner._settings.HUDC_timer and resmod_found and restoration.Options:GetValue("HUD/MainHUD") then
			self._heist_timer_panel = self._hud_panel:panel({
				y = 608,
				name = "heist_timer_panel",
				w = 2243,
				visible = true,
				layer = 0,
				valign = "top"
			})
		elseif HUDCleaner._settings.HUDC_timer and not resmod_found then
			self._heist_timer_panel = self._hud_panel:panel({
				y = 560,
				name = "heist_timer_panel",
				w = 2058,
				visible = true,
				layer = 0,
				valign = "top"
			})
		elseif HUDCleaner._settings.HUDC_timer and resmod_found and not restoration.Options:GetValue("HUD/MainHUD") then
			self._heist_timer_panel = self._hud_panel:panel({
				y = 560,
				name = "heist_timer_panel",
				w = 2058,
				visible = true,
				layer = 0,
				valign = "top"
			})
		else --idiot-proof design
			self._heist_timer_panel = self._hud_panel:panel({
				y = 0,
				name = "heist_timer_panel",
				h = 40,
				visible = true,
				layer = 0,
				valign = "top"
			})
		end
		
	local font_num = HUDCleaner.font_list[HUDCleaner._settings.font]
	local fn = tonumber(font_num)
	--log(fn.." FONT")
		
	local color_num = HUDCleaner.color_list[HUDCleaner._settings.color]
	local cn = tonumber(color_num)
	--log(cn.." COLOR")

		if fn==1 and cn==1 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.white
			})
		elseif fn==1 and cn==2 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.black
			})
		elseif fn==1 and cn==3 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.red
			})
		elseif fn==1 and cn==4 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.yellow
			})
		elseif fn==1 and cn==5 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.blue
			})
		elseif fn==1 and cn==6 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.purple
			})
		elseif fn==1 and cn==7 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.default_font,
				color = Color.green
			})
		elseif fn==2 and cn==1 then-----------------------------------------------------------
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.white
			})
		elseif fn==2 and cn==2 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.black
			})
		elseif fn==2 and cn==3 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.red
			})
		elseif fn==2 and cn==4 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.yellow
			})
		elseif fn==2 and cn==5 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.blue
			})
		elseif fn==2 and cn==6 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.purple
			})
		elseif fn==2 and cn==7 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.pd2_large_font,
				color = Color.green
			})
		elseif fn==3 and cn==1 then-----------------------------------------------------------
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.white
			})
		elseif fn==3 and cn==2 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.black
			})
		elseif fn==3 and cn==2 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.black
			})
		elseif fn==3 and cn==3 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.red
			})
		elseif fn==3 and cn==4 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.yellow
			})
		elseif fn==3 and cn==5 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.blue
			})
		elseif fn==3 and cn==6 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.purple
			})
		elseif fn==3 and cn==7 then
			self._timer_text = self._heist_timer_panel:text({
				name = "timer_text",
				vertical = "top",
				word_wrap = true,
				wrap = true,
				font_size = 28,
				align = "center",
				text = "00:00",
				layer = 1,
				font = tweak_data.menu.eroded_font,
				color = Color.green
			})
		end

		self._last_time = 0
		self._enabled = not tweak_hud.no_timer

		if not self._enabled then
			self._heist_timer_panel:hide()
		end
	end
end


if RequiredScript == "lib/managers/hud/hudheisttimer" then
	if HUDCleaner._settings.HUDC_timer_precision then
		function HUDHeistTimer:set_time(time)
			local inverted = false

			if time < 0 then
				inverted = true
				time = math.abs(time)
			end

			if not self._enabled or not inverted and time < self._last_time then
				return
			end

			self._last_time = time

			local hours = math.floor(time / 3600)
			time = time - hours * 3600
					
			local minutes = math.floor(time / 60)
			time = time - minutes * 60

			local precision_num = HUDCleaner.precision_list[HUDCleaner._settings.precision]
			local pn = tonumber(precision_num)
			--log(pn.." PRECISION DIGITS")
			
			if pn==3 then
				local text = hours > 0 and (hours < 10 and "0" .. hours or hours) .. ":" or "" .. string.format("%02d:%06.3f", minutes, time)
				self._timer_text:set_text(text)
			elseif pn==2 then
				local text = hours > 0 and (hours < 10 and "0" .. hours or hours) .. ":" or "" .. string.format("%02d:%05.2f", minutes, time)
				self._timer_text:set_text(text)
			elseif pn==1 then
				local text = hours > 0 and (hours < 10 and "0" .. hours or hours) .. ":" or "" .. string.format("%02d:%04.1f", minutes, time)
				self._timer_text:set_text(text)
			end
		end
	end
end

if RequiredScript == "lib/managers/hud/hudhint" then
	if HUDCleaner._settings.HUDC_hint_panel then
		Hooks:PostHook(HUDHint, "init", "HUDHintInit", function(self)
			self._hint_panel:set_center_y(self._hud_panel:h() / 2.7)
			local function hide_shit(o)
				o:set_alpha(0)
				o:hide()
				o:set_size(0,0)
			end
			hide_shit(self._hint_panel:child("marker"))
			hide_shit(self._hint_panel:child("clip_panel"))
			self._hint_panel:text({
				name = "hint_text",
				font_size = 32,
				font = tweak_data.menu.medium_font_no_outline,
				align = "center",
				vertical = "center",
				layer = 1,
				wrap = false,
				word_wrap = false
			})
			self._hint_panel:text({name = "hint_shadow_text", font_size = 32, font = tweak_data.menu.medium_font_no_outline, color = Color.black, align = "center", vertical = "center", layer = 0, wrap = false, word_wrap = false, y = 1, x = 1})
		end)

		Hooks:PostHook(HUDHint, "show", "HUDHintShow", function(self, params)
			local text = params.text
			self._hint_panel:child("hint_text"):set_text(utf8.to_upper(""))
		end)

		function HUDHint:_animate_show(hint_panel, done_cb, seconds, text)
			local split = {}
			for i = 1, string.len(text) do
				table.insert(split, string.sub(text, i, i))
			end
			local hint = ""
			hint_panel:show()
			hint_panel:set_alpha(1)
			local hint_text = hint_panel:child("hint_text")
			local hint_shadow_text = hint_panel:child("hint_shadow_text")
			local t = seconds
			local cs = 0.0
			while t > 0 do
				local dt = coroutine.yield()
				t = t - dt
				if t < 0.5 then
					hint_panel:set_alpha(t/0.5)
				end
				cs = cs - dt
				if cs < 0 and #split > 0 then
					hint = hint..table.remove(split, 1)
					hint_text:set_text(hint.."")
					hint_shadow_text:set_text(hint.."")
					cs = 0.025
				end
			end
			hint_panel:hide()
			done_cb()
		end
	end
end

if RequiredScript == "lib/managers/hudmanagerpd2" then
	if HUDCleaner._settings.HUDC_hinter then
		function HUDManager:show_hint(params) end
	end
end