if _G.HUDCleaner then
	return
end

_G.HUDCleaner = _G.HUDCleaner or {}
HUDCleaner._mod_path = ModPath
HUDCleaner._save_path = SavePath
HUDCleaner._save_name = "HUDC_settings.txt"
HUDCleaner._settings = {
	HUDC_small = true,
	HUDC_hud = true,
	HUDC_gage = true,
	HUDC_invalid = true,
	HUDC_maskup = true,
	HUDC_eq = true,
	HUDC_casing = true,
	HUDC_hint_panel = true,
	HUDC_timer = true,
	HUDC_timer_precision = true,
	HUDC_hinter = true
}
HUDCleaner.precision_list = {
	1,
	2,
	3
}
HUDCleaner.font_list = {
	1,
	2,
	3
}
HUDCleaner.color_list = {
	1,
	2,
	3,
	4,
	5,
	6,
	7
}

function HUDCleaner:json_encode(tab, path)
	local file = io.open(path, "w+")
	if file then
		file:write(json.encode(tab))
		file:close()
	end
end

function HUDCleaner:json_decode(tab, path)
	local file = io.open(path, "r")
	if file then
		for k, v in pairs(json.decode(file:read("*all")) or {}) do
			tab[k] = v
		end
		file:close()
	end
end

function HUDCleaner:save_settings()
	local path = self._save_path..self._save_name
	self:json_encode(self._settings, path)
end

function HUDCleaner:load_settings()
	local path = self._save_path..self._save_name
	self:json_decode(self._settings, path)
end

local save_exists = io.open(HUDCleaner._save_path..HUDCleaner._save_name, "r")
if save_exists ~= nil then
	save_exists:close()
	HUDCleaner:load_settings()
else
	HUDCleaner:save_settings()
end

--[[
Hooks:Add("LocalizationManagerPostInit", "HUDC_hook_LocalizationManagerPostInit", function(loc)
	loc:load_localization_file(HUDCleaner._mod_path.."loc/english.txt")
end)
]]

Hooks:Add("LocalizationManagerPostInit", "HUDC_loc", function(...)
	LocalizationManager:add_localized_strings({
		
		["HUDC_options_menu_title"] = "HUD Cleaner",
		["HUDC_options_menu_desc"] = "",
		
		["HUDC_loot_title"] = "Small loot pickup",
		["HUDC_loot_desc"] = "",
		
		["HUDC_hud_title"] = "Notifications on the middle",
		["HUDC_hud_desc"] = "",
		
		["HUDC_gage_title"] = "Gage packages",
		["HUDC_gage_desc"] = "",
		
		["HUDC_invalid_title"] = "Aim at a valid surface",
		["HUDC_invalid_desc"] = "",
		
		["HUDC_maskup_title"] = "Press [X] to mask up",
		["HUDC_maskup_desc"] = "",

		["HUDC_eq_title"] = "Deploying [deployable name]",
		["HUDC_eq_desc"] = "",
		
		["HUDC_casing_title"] = "You are in casing mode [...]",
		["HUDC_casing_desc"] = "",
		
		["HUDC_hint_panel_title"] = "Alpha Hint Panel",
		["HUDC_hint_panel_desc"] = "",
		
		["HUDC_timer_title"] = "Timer position change",
		["HUDC_timer_desc"] = "",
		
		["HUDC_timer_precision_title"] = "Precise Timer Toggle",
		["HUDC_timer_precision_desc"] = "",
		
		["HUDC_timer_nums_title"] = "Timer Precision",
		["HUDC_timer_nums_desc"] = "",
		["HUDC_timer_nums_1"] = "1 digit",
		["HUDC_timer_nums_2"] = "2 digits",
		["HUDC_timer_nums_3"] = "3 digits",
		
		["HUDC_font_title"] = "Timer Font",
		["HUDC_font_desc"] = "",
		["HUDC_font_1"] = "Default",
		["HUDC_font_2"] = "Large",
		["HUDC_font_3"] = "Eroded",
		
		["HUDC_color_title"] = "Timer Font Color",
		["HUDC_color_desc"] = "",
		["HUDC_color_1"] = "White",
		["HUDC_color_2"] = "Black",
		["HUDC_color_3"] = "Red",
		["HUDC_color_4"] = "Yellow",
		["HUDC_color_5"] = "Blue",
		["HUDC_color_6"] = "Purple",
		["HUDC_color_7"] = "Green",
		
		["HUDC_remove_title"] = "Restoration Mod/Hud Compat",
		["HUDC_remove_desc"] = "",
		
		["HUDC_add_title"] = "Revert Compat",
		["HUDC_add_desc"] = "",
		
		["HUDC_remove1_title"] = "Success",
		["HUDC_remove1_desc"] = "You don't have to worry about Resoration Mod/HUD incompatabilities now. Click 'Restore' button to revert the changes, if needed.",
		
		["HUDC_add2_title"] = "Success",
		["HUDC_add2_desc"] = "Restoration Mod/HUD changes reverted! You might experience incompatabilities from now on.",
		
		["HUDC_manual_title"] = "User Manual",
		["HUDC_manual_desc"] = "",
		
		["HUDC_hi_manual_title"] = "Welcome to User Manual section",
		["HUDC_user_manual"] = "All options and functionalities of HUD Cleaner are explained here. \n \n-Hints Hider \nPrevents all hints from appearing \n \n-Small loot pickup \nHides small loot pickup messages from hud and mutes it's sound (e.g money bundle pickups) \n \n-HUD notifications panel \nHides objective popups, equipment obtained, loot secured, civilian killed box on the middle of the hud \n \n-Gage packages \nHides gage package pickup message on hud and mutes it's sound \n \n-Aim at a valid surface \n Hides this hint \n \n-Press [X] to mask up \nHides this hint \n \n-Deploying [deployable name] \nHides this subtitle \n \n-You are in casing mode [...] \nRewrites it to make it more appealing \n \n-Alpha Hint Panel \nReplaces vanilla hudhint.lua code to the one from alpha version of PAYDAY2, it looks much better. ResMod feature standalone. Has no effect with Hints Hider function enabled. \n \n-Timer position change \nMoves the timer above user's name in player box \n \n-Precise timer toggle \nEnable or disable milliseconds entirely, required for Timer Precision option \n \n-Timer Precision \nChoose how many milliseconds should be displayed (1/2/3) \n \n-Timer Font \nAllows you to choose a font for your timer \n \n-Timer font color \nAllows you to choose a color for the font of your timer \n \n-Restoration Mod/HUD Compat \nApplies a fix for those mods \n \n-Revert Compat \nReverts the fix for those mods",
	
		["HUDC_hinter_title"] = "Hints Hider",
		["HUDC_hinter_desc"] = ""
	})
end)

Hooks:Add("MenuManagerInitialize", "HUDC_hook_MenuManagerInitialize", function(menu_manager)	
	MenuCallbackHandler.HUDC_callback_toggle = function(self, item)
		HUDCleaner._settings[item:name()] = item:value() == "on"
	end
	
	MenuCallbackHandler.HUDCleaner_callback_precision = function(this, item)
		HUDCleaner._settings.precision = tonumber(item:value()) or 3
		HUDCleaner:save_settings()
	end
	
	MenuCallbackHandler.HUDCleaner_callback_font = function(this, item)
		HUDCleaner._settings.font = tonumber(item:value()) or 3
		HUDCleaner:save_settings()
	end
	
	MenuCallbackHandler.HUDCleaner_callback_color = function(this, item)
		HUDCleaner._settings.color = tonumber(item:value()) or 7
		HUDCleaner:save_settings()
	end	

	MenuCallbackHandler.HUDC_callback_save = function(self, item)
		HUDCleaner:save_settings()
	end
	
	MenuCallbackHandler.HUDC_remove_clbk = function(self)
		local zip = "mods/HUD-Cleaner/compat/HUDHeistTimerCompat.zip"
		local mods_folder = "mods/Restoration-HUD-master/lua/managers/hud" or "mods/restoration-mod-gold/lua/managers/hud"
		unzip( zip, mods_folder )
		
		local title1,desc1
		if managers.player then
			title1 = "HUDC_remove1_title"
			desc1 = "HUDC_remove1_desc"
		end
		
		QuickMenu:new(managers.localization:text(title1),managers.localization:text(desc1),{
			{
				text = "Affirmative",
				is_cancel_button = true
			}
		},true)
		--log("COMPAT LOADED")
	end	
	
	MenuCallbackHandler.HUDC_add_clbk = function(self)
		local zip = "mods/HUD-Cleaner/compat/HUDHeistTimer.zip"
		local mods_folder = "mods/Restoration-HUD-master/lua/managers/hud" or "mods/restoration-mod-gold/lua/managers/hud"
		unzip( zip, mods_folder )
		
		local title2,desc2
		if managers.player then
			title2 = "HUDC_add2_title"
			desc2 = "HUDC_add2_desc"
		end
		
		QuickMenu:new(managers.localization:text(title2),managers.localization:text(desc2),{
			{
				text = "Affirmative",
				is_cancel_button = true
			}
		},true)
		--log("COMPAT REMOVED")
	end
	
	MenuCallbackHandler.HUDC_manual_clbk = function(self)
		local title3,desc3
		if managers.player then
			title3 = "HUDC_hi_manual_title"
			desc3 = "HUDC_user_manual"
		end
		
		QuickMenu:new(managers.localization:text(title3),managers.localization:text(desc3),{
			{
				text = "Close",
				is_cancel_button = true
			}
		},true)
		--log("USER MANUAL LOADED")
	end	
	
	MenuHelper:LoadFromJsonFile(HUDCleaner._mod_path.."menu/options.txt", HUDCleaner, HUDCleaner._settings)
end)